#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXSTR 255

typedef struct {
    char *nome;
} TVPlaneta;

typedef struct {
    char *estrela;
    TVPlaneta *planeta;
} TSPlanetario;

TSPlanetario SPCriar() {
    TSPlanetario sistemap;
    sistemap.estrela = NULL;
    sistemap.planeta = NULL;
    return sistemap;
}

void SPLeEstrela(TSPlanetario *sistemap) {
    char str[MAXSTR], provisorio[MAXSTR];

    fgets(provisorio, MAXSTR, stdin);
    sscanf(provisorio, "%[^\n, ,]", str);
    sistemap->estrela = (char *) malloc((strlen(str) + 1) * sizeof(char));

    if (sistemap->estrela != NULL) {
        strcpy(sistemap->estrela, str);
    }
}

void SPLePlaneta(TSPlanetario *sistemap, int i) {
    char str[MAXSTR], provisorio[MAXSTR];

    *str = '\0';

    if (sistemap->planeta == NULL) {
        sistemap->planeta = (TVPlaneta *) malloc(((i + 1) * sizeof(TVPlaneta)));
    } else {
        sistemap->planeta = (TVPlaneta *) realloc(sistemap->planeta, ((i + 1) * sizeof(TVPlaneta)));
    }

    fgets(provisorio, MAXSTR, stdin);
    sscanf(provisorio, "%[^\n, ,]", str);

    sistemap->planeta[i].nome = (char *) malloc((strlen(str) + 1) * sizeof(char));
    if (sistemap->planeta != NULL && sistemap->planeta[i].nome != NULL) {
        strcpy(sistemap->planeta[i].nome, str);
    }
}

int ContaPlaneta(TSPlanetario *sistemap) {
    int i, conta;

    i = 0;
    conta = 0;
    while ((strcmp(sistemap->planeta[i].nome, "\0") != 0)) {
        i++;
        conta++;
    }
    return conta;
}

void SPLibertar(TSPlanetario *sistemap) {
    int i, tamanho;

    if (sistemap->estrela != NULL) {
        free(sistemap->estrela);
        sistemap->estrela = NULL;
    }

    tamanho = ContaPlaneta(sistemap);
    for (i = 0; i <= tamanho; i++) {
        if (sistemap->planeta[i].nome != NULL) {
            free(sistemap->planeta[i].nome);
            sistemap->planeta[i].nome = NULL;
        }
    }

    if (sistemap->planeta != NULL) {
        free(sistemap->planeta);
        sistemap->planeta = NULL;
    }
}

/*---------- Programa ----------*/

TSPlanetario LerSistema() {
    TSPlanetario sistemap;
    int i;

    sistemap = SPCriar();
    SPLeEstrela(&sistemap);

    i = 0;
    do {
        SPLePlaneta(&sistemap, i);
        i++;
    } while (strcmp(sistemap.planeta[i - 1].nome, "\0") != 0);
    return sistemap;
}

void MostraSistema(TSPlanetario *sistemap) {
    printf("%s, sistema planetário com %d planetas", sistemap->estrela, ContaPlaneta(sistemap));
}

void main() {
    TSPlanetario sistemap;
    sistemap = LerSistema();
    MostraSistema(&sistemap);
    SPLibertar(&sistemap);
    exit(0);
}