#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXSTR 255

typedef struct {
    char *nome;
    float distancia;
} TVSatelite;

typedef struct {
    char *nome;
    float distancia;
    TVSatelite *satelite;
} TVPlaneta;

typedef struct {
    char *estrela;
    TVPlaneta *planeta;
} TSPlanetario;

TSPlanetario SPCriar() {
    TSPlanetario sistemap;
    sistemap.estrela = NULL;
    sistemap.planeta = NULL;
    return sistemap;
}

void AlocaMem(TSPlanetario *sistemap, int i, int j, char *str, char *estrutura) {
    if (strcmp(estrutura, "estrela") == 0) {
        sistemap->estrela = (char *) malloc((strlen(str) + 1) * sizeof(char));
    }

    if (strcmp(estrutura, "planeta") == 0) {
        if (sistemap->planeta == NULL) {
            sistemap->planeta = (TVPlaneta *) malloc(((i + 1) * sizeof(TVPlaneta)));
        } else {
            sistemap->planeta = (TVPlaneta *) realloc(sistemap->planeta, ((i + 1) * sizeof(TVPlaneta)));
        }
        sistemap->planeta[i].nome = (char *) malloc((strlen(str) + 1) * sizeof(char));
    }

    if (strcmp(estrutura, "satelite") == 0) {
        if (sistemap->planeta[i].satelite == NULL) {
            sistemap->planeta[i].satelite = (TVSatelite *) malloc(((j + 1) * sizeof(TVSatelite)));
        } else {
            sistemap->planeta[i].satelite = (TVSatelite *) realloc(sistemap->planeta[i].satelite,
                                                                   ((j + 1) * sizeof(TVSatelite)));
        }
        sistemap->planeta[i].satelite[j].nome = (char *) malloc((strlen(str) + 1) * sizeof(char));
    }
}

void SPLeEstrela(TSPlanetario *sistemap) {
    char str[MAXSTR], provisorio[MAXSTR];

    fgets(provisorio, MAXSTR, stdin);
    sscanf(provisorio, "%[^\n, ,]", str);
    AlocaMem(sistemap, (int) 0, (int) 0, str, "estrela");

    if (sistemap->estrela != NULL) {
        strcpy(sistemap->estrela, str);
    }
}

void SPLePlaneta(TSPlanetario *sistemap, int i, char *provisorio) {
    char str[MAXSTR];
    float distancia;

    *str = '\0';
    distancia = 0;
    sscanf(provisorio, "%[^\n, ,] %f", str, &distancia);
    AlocaMem(sistemap, i, (int) 0, str, "planeta");

    if (sistemap->planeta != NULL && sistemap->planeta[i].nome != NULL) {
        strcpy(sistemap->planeta[i].nome, str);
        sistemap->planeta[i].distancia = distancia;
    }
}

void SPLeSatelite(TSPlanetario *sistemap, int i, int j, char *provisorio) {
    char strs[MAXSTR];
    float distancia;

    *strs = '\0';
    distancia = 0;
    sscanf(provisorio, "%*c %[^\n, ] %f", strs, &distancia);
    AlocaMem(sistemap, i, j, strs, "satelite");

    if (sistemap->planeta[i].satelite != NULL && sistemap->planeta[i].satelite[j].nome != NULL) {
        strcpy(sistemap->planeta[i].satelite[j].nome, strs);
        sistemap->planeta[i].satelite[j].distancia = distancia;
    }
}

void SPLeSistema(TSPlanetario *sistemap) {
    char provisorio[MAXSTR];
    int iplaneta, isatelite;

    iplaneta = 0;
    do {
        fgets(provisorio, MAXSTR, stdin);
        if (provisorio[0] == '#') {
            SPLeSatelite(sistemap, iplaneta - 1, isatelite, provisorio);
            SPLeSatelite(sistemap, iplaneta - 1, isatelite + 1, "");
            isatelite++;
        } else {
            isatelite = 0;
            SPLePlaneta(sistemap, iplaneta, provisorio);
            sistemap->planeta[iplaneta].satelite = NULL;
            SPLeSatelite(sistemap, iplaneta, isatelite, "");
            iplaneta++;
        }
    } while ((strcmp(sistemap->planeta[iplaneta - 1].nome, "\0") != 0));
}

int ContaAstros(TSPlanetario *sistemap, int i, char *estrutura) {
    int j, conta;

    conta = 0;
    if (strcmp(estrutura, "planeta") == 0) {
        while ((strcmp(sistemap->planeta[i].nome, "\0") != 0)) {
            i++;
            conta++;
        }
    }

    if (strcmp(estrutura, "satelite") == 0) {
        j = 0;
        while ((strcmp(sistemap->planeta[i].satelite[j].nome, "\0") != 0)) {
            j++;
            conta++;
        }
    }

    return conta;
}

void OrdenaAstrosNome(TSPlanetario *sistemap) {
    int i, j, h, tplaneta, tsatelite;
    TSPlanetario aux;

    tplaneta = ContaAstros(sistemap, 0, "planeta");
    aux.planeta = (TVPlaneta *) malloc(((1) * sizeof(TVPlaneta)));

    if (aux.planeta != NULL) {
        for (i = 0; i < tplaneta - 1; i++) {
            for (j = i + 1; j < tplaneta; j++) {
                if (strcmp(sistemap->planeta[i].nome, sistemap->planeta[j].nome) > 0) {
                    aux.planeta[0] = sistemap->planeta[i];
                    sistemap->planeta[i] = sistemap->planeta[j];
                    sistemap->planeta[j] = aux.planeta[0];
                }
            }
            tsatelite = ContaAstros(sistemap, i, "satelite");
            aux.planeta->satelite = (TVSatelite *) malloc(((1) * sizeof(TVSatelite)));
            for (j = 0; j < tsatelite - 1; j++) {
                for (h = j + 1; h < tsatelite; h++) {
                    if (strcmp(sistemap->planeta[i].satelite[j].nome, sistemap->planeta[i].satelite[h].nome) > 0) {
                        aux.planeta[0].satelite[0] = sistemap->planeta[i].satelite[j];
                        sistemap->planeta[i].satelite[j] = sistemap->planeta[i].satelite[h];
                        sistemap->planeta[i].satelite[h] = aux.planeta[0].satelite[0];
                    }
                }
            }
        }
    }
    free(aux.planeta->satelite);
    free(aux.planeta);
}

void OrdenaAstrosUA(TSPlanetario *sistemap) {
    int i, j, h, tplaneta, tsatelite;
    TSPlanetario aux;

    tplaneta = ContaAstros(sistemap, 0, "planeta");
    aux.planeta = (TVPlaneta *) malloc(((1) * sizeof(TVPlaneta)));

    if (aux.planeta != NULL) {
        for (i = 0; i < tplaneta - 1; i++) {
            for (j = i + 1; j < tplaneta; j++) {
                if (sistemap->planeta[i].distancia > sistemap->planeta[j].distancia) {
                    aux.planeta[0] = sistemap->planeta[i];
                    sistemap->planeta[i] = sistemap->planeta[j];
                    sistemap->planeta[j] = aux.planeta[0];
                }
            }
            tsatelite = ContaAstros(sistemap, i, "satelite");
            aux.planeta->satelite = (TVSatelite *) malloc(((1) * sizeof(TVSatelite)));
            for (j = 0; j < tsatelite - 1; j++) {
                for (h = j + 1; h < tsatelite; h++) {
                    if (sistemap->planeta[i].satelite[j].distancia > sistemap->planeta[i].satelite[h].distancia) {
                        aux.planeta[0].satelite[0] = sistemap->planeta[i].satelite[j];
                        sistemap->planeta[i].satelite[j] = sistemap->planeta[i].satelite[h];
                        sistemap->planeta[i].satelite[h] = aux.planeta[0].satelite[0];
                    }
                }
            }
        }
    }
    free(aux.planeta->satelite);
    free(aux.planeta);
}

void OrdenaAstros(TSPlanetario *sistemap, int ordem) {
    if (ordem == 2) {
        OrdenaAstrosNome(sistemap);
    }

    if (ordem == 3) {
        OrdenaAstrosUA(sistemap);
    }
}

void FiltraNomeAstros(TSPlanetario *sistemap, char *str) {
    int i, j, h, tplaneta, tsatelite;

    if (strcmp(str, "*") != 0) {
        tplaneta = ContaAstros(sistemap, 0, "planeta");
        for (i = 0; i < tplaneta; i++) {
            while (i < tplaneta && strstr(sistemap->planeta[i].nome, str) == NULL) {
                for (j = i; j <= tplaneta; j++)
                    sistemap->planeta[j] = sistemap->planeta[j + 1];
                tplaneta--;
            }

            tsatelite = ContaAstros(sistemap, i, "satelite");
            for (j = 0; j < tsatelite; j++) {
                while (j < tsatelite && strstr(sistemap->planeta[i].satelite[j].nome, str) == NULL) {
                    for (h = j; h <= tsatelite; h++)
                        sistemap->planeta[i].satelite[h] = sistemap->planeta[i].satelite[h + 1];
                    tsatelite--;
                }
            }
            sistemap->planeta[i].satelite = (TVSatelite *) realloc(sistemap->planeta[i].satelite,
                                                                   ((tsatelite + 1) * sizeof(TVSatelite)));
        }
        sistemap->planeta = (TVPlaneta *) realloc(sistemap->planeta, ((tplaneta + 1) * sizeof(TVPlaneta)));
    }
}

void FiltraMin(TSPlanetario *sistemap, float minimo) {
    int i, j, h, tplaneta, tsatelite;

    if (minimo >= 0) {
        tplaneta = ContaAstros(sistemap, 0, "planeta");
        for (i = 0; i < tplaneta; i++) {
            while (i < tplaneta && sistemap->planeta[i].distancia < minimo) {
                for (j = i; j <= tplaneta; j++)
                    sistemap->planeta[j] = sistemap->planeta[j + 1];
                tplaneta--;
            }

            tsatelite = ContaAstros(sistemap, i, "satelite");
            for (j = 0; j < tsatelite; j++) {
                while (j < tsatelite && sistemap->planeta[i].satelite[j].distancia < minimo) {
                    for (h = j; h <= tsatelite; h++)
                        sistemap->planeta[i].satelite[h] = sistemap->planeta[i].satelite[h + 1];
                    tsatelite--;
                }
            }
            sistemap->planeta[i].satelite = (TVSatelite *) realloc(sistemap->planeta[i].satelite,
                                                                   ((tsatelite + 1) * sizeof(TVSatelite)));
        }
        sistemap->planeta = (TVPlaneta *) realloc(sistemap->planeta, ((tplaneta + 1) * sizeof(TVPlaneta)));
    }
}

void FiltraMax(TSPlanetario *sistemap, float maximo) {
    int i, j, h, tplaneta, tsatelite;

    if (maximo >= 0) {
        tplaneta = ContaAstros(sistemap, 0, "planeta");
        for (i = 0; i < tplaneta; i++) {
            while (i < tplaneta && sistemap->planeta[i].distancia > maximo) {
                for (j = i; j <= tplaneta; j++)
                    sistemap->planeta[j] = sistemap->planeta[j + 1];
                tplaneta--;
            }

            tsatelite = ContaAstros(sistemap, i, "satelite");
            for (j = 0; j < tsatelite; j++) {
                while (j < tsatelite && sistemap->planeta[i].satelite[j].distancia > maximo) {
                    for (h = j; h <= tsatelite; h++)
                        sistemap->planeta[i].satelite[h] = sistemap->planeta[i].satelite[h + 1];
                    tsatelite--;
                }
            }
            sistemap->planeta[i].satelite = (TVSatelite *) realloc(sistemap->planeta[i].satelite,
                                                                   ((tsatelite + 1) * sizeof(TVSatelite)));
        }
        sistemap->planeta = (TVPlaneta *) realloc(sistemap->planeta, ((tplaneta + 1) * sizeof(TVPlaneta)));
    }
}

void SPLeOpcoes(TSPlanetario *sistemap) {
    char provisorio[MAXSTR], str[MAXSTR];
    int ordem;
    float minimo, maximo;
    fgets(provisorio, MAXSTR, stdin);
    sscanf(provisorio, "%d %[^\n, ] %f %f", &ordem, str, &minimo, &maximo);
    OrdenaAstros(sistemap, ordem);
    FiltraNomeAstros(sistemap, str);
    FiltraMin(sistemap, minimo);
    FiltraMax(sistemap, maximo);

}

void SPLibertar(TSPlanetario *sistemap) {
    int i, j, tplaneta, tsatelite;

    if (sistemap->estrela != NULL) {
        free(sistemap->estrela);
        sistemap->estrela = NULL;
    }

    tplaneta = ContaAstros(sistemap, 0, "planeta");
    for (i = 0; i <= tplaneta; i++) {
        tsatelite = ContaAstros(sistemap, i, "satelite");
        for (j = 0; j <= tsatelite; j++) {
            if (sistemap->planeta[i].satelite[j].nome != NULL) {
                free(sistemap->planeta[i].satelite[j].nome);
                sistemap->planeta[i].satelite[j].nome = NULL;
                sistemap->planeta[i].satelite[j].distancia = 0;
            }
        }

        if (sistemap->planeta[i].satelite != NULL) {
            free(sistemap->planeta[i].satelite);
            sistemap->planeta[i].satelite = NULL;
        }

        if (sistemap->planeta[i].nome != NULL) {
            free(sistemap->planeta[i].nome);
            sistemap->planeta[i].nome = NULL;
            sistemap->planeta[i].distancia = 0;
        }
    }

    if (sistemap->planeta != NULL) {
        free(sistemap->planeta);
        sistemap->planeta = NULL;
    }
}

/*---------- Programa ----------*/

TSPlanetario ProcessaSistema() {
    TSPlanetario sistemap;

    sistemap = SPCriar();
    SPLeEstrela(&sistemap);
    SPLeSistema(&sistemap);
    SPLeOpcoes(&sistemap);
    return sistemap;
}

void MostraSistema(TSPlanetario *sistemap) {
    int i, j, tplaneta, tsatelite;
    tplaneta = ContaAstros(sistemap, 0, "planeta");
    printf("%s:\n", sistemap->estrela);
    for (i = 0; i < tplaneta; i++) {
        printf("- %s %.2f\n", sistemap->planeta[i].nome, sistemap->planeta[i].distancia);
        tsatelite = ContaAstros(sistemap, i, "satelite");
        for (j = 0; j < tsatelite; j++) {
            printf("--- %s %.4f\n", sistemap->planeta[i].satelite[j].nome, sistemap->planeta[i].satelite[j].distancia);
        }
    }
}

void main() {
    TSPlanetario sistemap;
    sistemap = ProcessaSistema();
    MostraSistema(&sistemap);
    SPLibertar(&sistemap);
    exit(0);
}